=== vhdlparser/Makefile ===
#
# Copyright (C) 1997-2015 by Dimitri van Heesch.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation under the terms of the GNU General Public License is hereby
# granted. No representations are made about the suitability of this software
# for any purpose. It is provided "as is" without express or implied warranty.
# See the GNU General Public License for more details.
#
# Documents produced by doxygen are derivative works derived from the
# input used in their production; they are not affected by this license.
#

#
# Files generated by javacc 
#
GEN_FILES=CharStream.cc CharStream.h ErrorHandler.h ParseException.cc ParseException.h \
	      Token.cc Token.h TokenManager.h TokenMgrError.cc TokenMgrError.h VhdlParser.cc VhdlParser.h \
	      VhdlParserConstants.h VhdlParserTokenManager.cc VhdlParserTokenManager.h \
              JavaCC.h
#
# Generate parser (default target)
#
# when generating the parser with debug options it will look like:
#   make JAVACC_FLAGS=-debug_parser 
#  or
#   make JAVACC_FLAGS="-debug_parser -debug_lookahead"
#
# Available debug options:
#  -debug_parser
#  -debug_token_manager
#  -debug_lookahead
#
# For other javacc settings / options consult the documentation of javacc.

regenerate:
	@rm -f $(GEN_FILES)
	@javacc $(JAVACC_FLAGS) vhdlparser.jj
	@cp JavaCC.h.in JavaCC.h

#
# reset the generated files back to their versions from git.
#

reset_gen_files:
	@rm -f $(GEN_FILES)
	@git checkout $(GEN_FILES)

help:
	@echo "Targets:"
	@echo "  regenerate (default)"
	@echo "  reset_gen_files"

FORCE:
