=== addon/doxmlparser/CMakeLists.txt ===

add_subdirectory(src)
add_subdirectory(examples)
add_subdirectory(test)
