=== debian/changelog ===
doxygen (1.8.17-0ubuntu2) focal; urgency=medium

  * Fix FTBFS with modern sass. Patch from Debian.

 -- William Grant <wgrant@ubuntu.com>  Thu, 09 Apr 2020 12:18:00 +1000

doxygen (1.8.17-0ubuntu1) focal; urgency=medium

  * New upstream version.
  * Build using LLVM 10.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 09 Mar 2020 12:13:57 +0100

doxygen (1.8.16-2build1) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 10:58:02 +0000
